diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/simulator.h ns-3.31/src/core/model/simulator.h
--- ns-3.30.1/src/core/model/simulator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/simulator.h	2020-06-27 17:38:30.000000000 -0700
@@ -975,248 +339,49 @@
    */
   /** @{ */
   /**
-   * Schedule an event to expire when Simulator::Destroy is called.
-   * All events scheduled to expire at "Destroy" time are scheduled FIFO, 
-   * after all normal events have expired and only when 
+   * Schedule an event to run at the end of the simulation, when Simulator::Destroy() is called.
+   * All events scheduled to expire at "Destroy" time are scheduled FIFO,
+   * after all normal events have expired and only when
    * Simulator::Destroy is invoked.
    *
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj);
-
-  /**
-   * @see ScheduleDestroy(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1);
-
-  /**
-   * @see ScheduleDestroy(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ,
-            typename T1, typename T2>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleDestroy(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleDestroy(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, 
-                                  T1 a1, T2 a2, T3 a3, T4 a4);
-  /**
-   * @see ScheduleDestroy(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @tparam T5 @deduced Type of fifth argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   * @param [in] a5 The fifth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, 
-                                  T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-
-  /**
-   * @param mem_ptr member method pointer to invoke
-   * @param obj the object on which to invoke the member method
-   * @param a1 the first argument to pass to the invoked method
-   * @param a2 the second argument to pass to the invoked method
-   * @param a3 the third argument to pass to the invoked method
-   * @param a4 the fourth argument to pass to the invoked method
-   * @param a5 the fifth argument to pass to the invoked method
-   * @param a6 the sixth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static EventId ScheduleDestroy (MEM mem_ptr, OBJ obj, 
-                                  T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
-
-  /**
-   * @copybrief ScheduleDestroy(MEM,OBJ)
-   * When Simulator::Destroy() is called, the
-   * function will be invoked with any supplied arguments.
-   * @param [in] f The function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  static EventId ScheduleDestroy (void (*f)(void));
-
-  /**
-   * @see ScheduleDestory((*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1,
-            typename T1>
-  static EventId ScheduleDestroy (void (*f)(U1), T1 a1);
-
-  /**
-   * @see ScheduleDestory((*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2,
-            typename T1, typename T2>
-  static EventId ScheduleDestroy (void (*f)(U1,U2), T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleDestory((*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2, typename U3,
-            typename T1, typename T2, typename T3>
-  static EventId ScheduleDestroy (void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleDestory((*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2, typename U3, typename U4,
-            typename T1, typename T2, typename T3, typename T4>
-  static EventId ScheduleDestroy (void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4);
-
-  /**
-   * @see ScheduleDestory((*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam U5 @deduced Formal type of the fifth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @tparam T5 @deduced Actual type of the fifth argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   * @param [in] a5 The fifth argument to pass to the function to invoke
+   * We leverage SFINAE to discard this overload if the second argument is
+   * convertible to Ptr<EventImpl> or is a function pointer.
+   *
+   * @tparam FUNC @deduced Template type for the function to invoke.
+   * @tparam Ts @deduced Actual function argument types.
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to MakeEvent.
    * @return The EventId of the scheduled event.
    */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5,
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static EventId ScheduleDestroy (void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
+  template <typename FUNC,
+            typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type = 0,
+            typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type = 0,
+            typename... Ts>
+  static EventId ScheduleDestroy (FUNC f, Ts&&... args);
 
   /**
-   * @param f the function to invoke
-   * @param a1 the first argument to pass to the function to invoke
-   * @param a2 the second argument to pass to the function to invoke
-   * @param a3 the third argument to pass to the function to invoke
-   * @param a4 the fourth argument to pass to the function to invoke
-   * @param a5 the fifth argument to pass to the function to invoke
-   * @param a6 the sixth argument to pass to the function to invoke
+   * Schedule an event to run at the end of the simulation, when Simulator::Destroy() is called.
+   * All events scheduled to expire at "Destroy" time are scheduled FIFO,
+   * after all normal events have expired and only when
+   * Simulator::Destroy is invoked.
+   *
+   * @tparam Us @deduced Formal function argument types.
+   * @tparam Ts @deduced Actual function argument types.
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to MakeEvent.
    * @return The EventId of the scheduled event.
    */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static EventId ScheduleDestroy (void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
+  template <typename... Us, typename... Ts>
+  static EventId ScheduleDestroy (void (*f)(Us...), Ts&&... args);
 
   /** @} */  // Schedule events to run when Simulator:Destroy() is called.
 
   /**
-   * Remove an event from the event list. 
-   * 
-   * This method has the same visible effect as the 
+   * Remove an event from the event list.
+   *
+   * This method has the same visible effect as the
    * ns3::EventId::Cancel method
-   * but its algorithmic complexity is much higher: it has often 
+   * but its algorithmic complexity is much higher: it has often
    * O(log(n)) complexity, sometimes O(n), sometimes worse.
    * Note that it is not possible to remove events which were scheduled
    * for the "destroy" time. Doing so will result in a program error (crash).
@@ -1229,13 +394,13 @@
    * Set the cancel bit on this event: the event's associated function
    * will not be invoked when it expires.
    *
-   * This method has the same visible effect as the 
-   * ns3::Simulator::Remove method but its algorithmic complexity is 
+   * This method has the same visible effect as the
+   * ns3::Simulator::Remove method but its algorithmic complexity is
    * much lower: it has O(1) complexity.
    * This method has the exact same semantics as ns3::EventId::Cancel.
    * Note that it is not possible to cancel events which were scheduled
    * for the "destroy" time. Doing so will result in a program error (crash).
-   * 
+   *
    * @param [in] id the event to cancel
    */
   static void Cancel (const EventId &id);
@@ -1276,7 +441,7 @@
   /**
    * Get the maximum representable simulation time.
    *
-   * @return The maximum simulation time at which an event 
+   * @return The maximum simulation time at which an event
    *          can be scheduled.
    *
    * The returned value will always be bigger than or equal to Simulator::Now.
@@ -1328,7 +493,7 @@
    * @return The system id for this simulator.
    */
   static uint32_t GetSystemId (void);
-  
+
 private:
   /** Default constructor. */
   Simulator ();
@@ -1354,7 +519,7 @@
    * @return The EventId.
    */
   static EventId DoScheduleDestroy (EventImpl *event);
-  
+
 };  // class Simulator
 
 /**
